package com.inca.npbusi.saset.inorder;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.communicate.ClientRequest;
import com.inca.np.communicate.ServerResponse;
import com.inca.np.communicate.StringCommand;
import com.inca.np.demo.communicate.RemotesqlHelper;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.CTable;
import com.inca.np.gui.control.DBColumnDisplayInfo;
import com.inca.np.gui.control.DBTableModel;
import com.inca.np.gui.ste.CSteModel;
import com.inca.np.util.DecimalHelper;
import com.inca.np.util.SendHelper;
import com.inca.npbusi.inf.hov.Zx_su_price_type_hov;
import com.inca.npbusi.saset.inorder.hov.Husemv_order_dtl_hov;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_sa_goods_price_hov.Bms_sa_goods_price_hov;
import java.awt.Color;
import java.awt.Component;
import java.awt.Frame;
import java.awt.HeadlessException;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

public class Husemv_order_dtl_ste extends CSteModelAp {
   JCheckBox a = null;
   JCheckBox b = null;

   public Husemv_order_dtl_ste(CFrame frame) throws HeadlessException {
      super(frame, "医院使用单对码");
   }

   public String getTablename() {
      return "HUSEMV_ORDER_DTL_V";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.saset.inorder.Husemv_order_dtl_ste.保存医院使用单对码";
   }

   protected void on_itemvaluechange(int row, String colname, String value) {
      if (colname.equals("goodsname")) {
         this.setItemValue(row, "operatingid", ClientUserManager.getCurrentUser().getUserid());
         this.setItemValue(row, "operatingperson", ClientUserManager.getCurrentUser().getUsername());
         this.setItemValue(row, "operatingmac", ClientUserManager.getCurrentUser().getMac());
         this.setItemValue(row, "operdate", NpbusiDBHelper.getSysdate());
         this.setItemValue(row, "baseratio", "1");
         this.setItemValue(row, "priceid", "");
         this.getItemValue(row, "goodsid");
         this.getItemValue(row, "yljgbm");
         Bms_sa_goods_price_hov hov = new Bms_sa_goods_price_hov();
         hov.setOtherwheres(" ((customid is null or customid = " + this.getItemValue(row, "yljgbm") + ") and goodsid = " + this.getItemValue(row, "goodsid") + " and entryid=1)");
         DBTableModel model = hov.showDialog((Frame)null, "选择货品价格");
         this.setItemValue(row, "priceid", model.getItemValue(0, "priceid"));
         Zx_su_price_type_hov suhov = new Zx_su_price_type_hov();
         suhov.setOtherwheres("workflag =6 and goodsid=" + this.getItemValue(row, "goodsid") + " and entryid=" + ClientUserManager.getCurrentUser().getEntryid());
         DBTableModel sumodel = suhov.showDialog((Frame)null, "选择货品采购价格");
         this.setItemValue(row, "supriceid", sumodel.getItemValue(0, "priceid"));
         this.doSave();
      }

      super.on_itemvaluechange(row, colname, value);
   }

   public String getHovOtherWheres(int row, String colname) {
      if (colname.equals("goodsid")) {
         return "goodsid not in(select  nvl(goodsid,0) goodsid from hrp_goods where yljgbm=" + this.getItemValue(row, "yljgbm") + " )";
      } else if (colname.equals("priceid")) {
         if (this.getItemValue(row, "goodsid").equals("")) {
            this.warnMessage("提示", "货品未选择，请先对照货品！！");
            return "1>2";
         } else {
            return " ((customid is null or customid = " + this.getItemValue(row, "yljgbm") + ") and goodsid = " + this.getItemValue(row, "goodsid") + " and entryid=1)";
         }
      } else if (colname.equals("supriceid")) {
         if (this.getItemValue(row, "goodsid").equals("")) {
            this.warnMessage("提示", "货品未选择，请先对照货品！！");
            return "1>2";
         } else {
            return "( workflag =6 and goodsid=" + this.getItemValue(row, "goodsid") + " and entryid=" + ClientUserManager.getCurrentUser().getEntryid() + ")";
         }
      } else if (colname.equals("PRICEID")) {
         if (this.getItemValue(row, "goodsid").equals("")) {
            this.warnMessage("提示", "货品未选择，请先对照货品！！");
            return "1>2";
         } else {
            String customid = this.getItemValue(row, "HID");
            String goodsid = this.getItemValue(row, "goodsid");
            String entryid = ClientUserManager.getCurrentUser().getEntryid();
            return String.format("(customid is null or customid =%s) and goodsid=%s and entryid=%s", this.isNullRe_one(customid), this.isNullRe_one(goodsid), this.isNullRe_one(entryid));
         }
      } else {
         return super.getHovOtherWheres(row, colname);
      }
   }

   private String isNullRe_one(String exec_text) {
      String return_value = "-1";
      if (exec_text != null && !exec_text.trim().isEmpty()) {
         return_value = exec_text;
      }

      return return_value;
   }

   protected String getOtherWheres() {
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      return " entryid=" + entryid;
   }

   protected int on_actionPerformed(String command) {
      if (command.equals("库存数据匹配")) {
         String goodsid = this.getItemValue(this.getRow(), "goodsid");
         if (goodsid != null && !"".equals(goodsid)) {
            this.infoMessage("提示", "医院使用单已对码！");
            return -1;
         } else {
            this.chooseStockOrder();
            return 0;
         }
      } else {
         return super.on_actionPerformed(command);
      }
   }

   private void chooseStockOrder() {
      String hmoveid = this.getItemValue(this.getRow(), "HMOVEID");
      String moveId = this.getItemValue(this.getRow(), "MOVEID");
      String storageid = this.getItemValue(this.getRow(), "storageid");
      String HLOTNO = this.getItemValue(this.getRow(), "HLOTNO");
      String hgoodsqty = this.getItemValue(this.getRow(), "HGOODSQTY");
      String hid = this.getItemValue(this.getRow(), "HID");
      if (hmoveid != null && !"".equals(hmoveid)) {
         this.infoMessage("提示", "医院已有移库单ID，不允许数据匹配！");
      } else if (moveId != null && !"".equals(moveId)) {
         this.infoMessage("提示", "已有移库单ID，不允许数据匹配！");
      } else {
         Husemv_order_dtl_hov husemv_order_dtl_hov = new Husemv_order_dtl_hov();
         husemv_order_dtl_hov.setOtherwheres(" STORAGEID=" + storageid + " and LOTNO= '" + HLOTNO + "' and availableqty_truereal >0  ");
         DBTableModel showDialog = husemv_order_dtl_hov.showDialog(this.frame, "选择库存生成数据");
         if (showDialog != null) {
            CTable table;
            int[] selectedRows = (table = husemv_order_dtl_hov.getTable()).getSelectedRows();
            DBTableModel dbTableModel = (DBTableModel)table.getModel();
            if (selectedRows.length > 0) {
               String goodsid = dbTableModel.getItemValue(selectedRows[0], "GOODSID");
               this.setItemValue(this.getRow(), "GOODSID", goodsid);
               this.setItemValue(this.getRow(), "GOODSNAME", dbTableModel.getItemValue(selectedRows[0], "GOODSNAME"));
               this.setItemValue(this.getRow(), "GOODSTYPE", dbTableModel.getItemValue(selectedRows[0], "GOODSTYPE"));
               String erpgoodsqty = dbTableModel.getItemValue(selectedRows[0], "GOODSQTY");
               String goodsqty = dbTableModel.getItemValue(selectedRows[0], "GOODSQTY");
               int comparaDecimal = DecimalHelper.comparaDecimal(hgoodsqty, goodsqty);
               if (comparaDecimal == -1) {
                  goodsqty = hgoodsqty;
               }

               this.setItemValue(this.getRow(), "GOODSQTY", goodsqty);
               String sql = " select d.toprice,d.priceid from web_custom_pr_def_v w,bms_entry_pralter_dtl_v d where w.storageid = d.priceid and w.compayid = " + hid + " and  " + " d.goodsid = " + goodsid + " ";
               RemotesqlHelper rh = new RemotesqlHelper();
               DBTableModel model = null;

               try {
                  model = rh.doSelect(sql, 0, 1);
               } catch (Exception var25) {
                  Exception e = var25;
                  e.printStackTrace();
               }

               String resp;
               String posid;
               if (model != null && model.getRowCount() > 0) {
                  posid = model.getItemValue(0, "toprice");
                  String priceid = model.getItemValue(0, "priceid");
                  this.setItemValue(this.getRow(), "PRICEID", priceid);
                  this.setItemValue(this.getRow(), "UNITPRICE", posid);
                  resp = DecimalHelper.multi(goodsqty, posid, 2);
                  this.setItemValue(this.getRow(), "AMOUNT", resp);
               }

               this.setItemValue(this.getRow(), "LOTNO", dbTableModel.getItemValue(selectedRows[0], "LOTNO"));
               this.setItemValue(this.getRow(), "PRODDATE", dbTableModel.getItemValue(selectedRows[0], "PRODDATE"));
               this.setItemValue(this.getRow(), "INVALIDDATE", dbTableModel.getItemValue(selectedRows[0], "INVALIDDATE"));
               this.setItemValue(this.getRow(), "FACTORYNAME", dbTableModel.getItemValue(selectedRows[0], "FACTORYNAME"));
               this.setItemValue(this.getRow(), "REGISTDOCNO", dbTableModel.getItemValue(selectedRows[0], "REGISTDOCNO"));
               this.setItemValue(this.getRow(), "USESTATUS", "1");
               this.setItemValue(this.getRow(), "GOODSDTLID", dbTableModel.getItemValue(selectedRows[0], "GOODSDTLID"));
               this.setItemValue(this.getRow(), "BATCHID", dbTableModel.getItemValue(selectedRows[0], "BATCHID"));
               this.setItemValue(this.getRow(), "LOTID", dbTableModel.getItemValue(selectedRows[0], "LOTID"));
               posid = dbTableModel.getItemValue(selectedRows[0], "POSID");
               if (posid == null || "".equals(posid)) {
                  posid = "0";
               }

               this.setItemValue(this.getRow(), "POSID", posid);
               this.setItemValue(this.getRow(), "GOODSSTATUSID", dbTableModel.getItemValue(selectedRows[0], "GOODSSTATUSID"));
               this.setItemValue(this.getRow(), "GOODSUSEUNIT", dbTableModel.getItemValue(selectedRows[0], "GOODSUSEUNIT"));
               ClientRequest req = new ClientRequest();
               req.addCommand(new StringCommand("husemv_order_dtl.库存数据匹配"));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "rid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "id")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsdtlid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "lotid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "batchid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "posid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsstatusid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hgoodsqty")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsqty")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hunitprice")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hgoodscode")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hgoodsname")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hgoodstype")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hgoodsuseunit")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hlotno")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hproddate")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hinvaliddate")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "usedate")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hfactoryname")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hregistdocno")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "storageid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "hid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsname")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodstype")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "priceid")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "unitprice")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "lotno")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "proddate")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "invaliddate")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "factoryname")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "registdocno")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "usestatus")));
               req.addCommand(new StringCommand(this.getItemValue(this.getRow(), "goodsuseunit")));
               req.addCommand(new StringCommand(erpgoodsqty));
               req.addCommand(new StringCommand(dbTableModel.getItemValue(selectedRows[0], "")));
               resp = null;

               try {
                  ServerResponse resp = SendHelper.sendRequest(req);
                  String sercmd = ((StringCommand)resp.commandAt(0)).getString();
                  if (sercmd.startsWith("+OK")) {
                     this.infoMessage("提示", "库存数据匹配成功!");
                     this.doRequery();
                  } else {
                     this.infoMessage("提示", "库存数据匹配失败，原因:" + sercmd);
                     this.setItemValue(this.getRow(), "GOODSID", "");
                     this.setItemValue(this.getRow(), "GOODSNAME", "");
                     this.setItemValue(this.getRow(), "GOODSTYPE", "");
                     this.setItemValue(this.getRow(), "PRICEID", "");
                     this.setItemValue(this.getRow(), "UNITPRICE", "");
                     this.setItemValue(this.getRow(), "AMOUNT", "");
                     this.setItemValue(this.getRow(), "LOTNO", "");
                     this.setItemValue(this.getRow(), "PRODDATE", "");
                     this.setItemValue(this.getRow(), "INVALIDDATE", "");
                     this.setItemValue(this.getRow(), "FACTORYNAME", "");
                     this.setItemValue(this.getRow(), "REGISTDOCNO", "");
                     this.setItemValue(this.getRow(), "USESTATUS", "1");
                     this.setItemValue(this.getRow(), "GOODSDTLID", "");
                     this.setItemValue(this.getRow(), "BATCHID", "");
                     this.setItemValue(this.getRow(), "LOTID", "");
                     this.setItemValue(this.getRow(), "POSID", "");
                     this.setItemValue(this.getRow(), "GOODSSTATUSID", "");
                     this.setItemValue(this.getRow(), "GOODSUSEUNIT", "");
                     this.setItemValue(this.getRow(), "GOODSQTY", "");
                  }
               } catch (Exception var24) {
                  Exception e = var24;
                  e.printStackTrace();
               }

            }
         }
      }
   }

   public void recreateDBModel() {
      super.recreateDBModel();
      TableColumnModel columnModel = this.table.getColumnModel();

      for(int i = 0; i < columnModel.getColumnCount(); ++i) {
         TableColumn column = columnModel.getColumn(i);
         DBColumnDisplayInfo dbColumnDisplayInfo;
         if (!(dbColumnDisplayInfo = (DBColumnDisplayInfo)this.formcolumndisplayinfos.elementAt(column.getModelIndex())).getColtype().equals("行号")) {
            column.setCellRenderer(new ColorcellRender(dbColumnDisplayInfo));
         }
      }

   }

   final class ColorcellRender extends CSteModel.PlainTablecellRender {
      Color a = new Color(255, 184, 184);
      Color b;

      public ColorcellRender(DBColumnDisplayInfo dbColumnDisplayInfo) {
         super(Husemv_order_dtl_ste.this, dbColumnDisplayInfo);
         new Color(60, 90, 50);
         this.b = new Color(160, 240, 140);
      }

      public final Component getTableCellRendererComponent(JTable table, Object o, boolean b, boolean b2, int n, int n2) {
         Component tableCellRendererComponent = super.getTableCellRendererComponent(table, o, b, b2, n, n2);
         if (n >= 0 && n < Husemv_order_dtl_ste.this.getRowCount()) {
            String hunitprice = Husemv_order_dtl_ste.this.getItemValue(n, "HUNITPRICE");
            String unitprice = Husemv_order_dtl_ste.this.getItemValue(n, "UNITPRICE");
            int comparaDecimal = DecimalHelper.comparaDecimal(hunitprice, unitprice);
            if (comparaDecimal != 0) {
               tableCellRendererComponent.setBackground(this.a);
            }

            if (b) {
               tableCellRendererComponent.setForeground(table.getSelectionForeground());
               tableCellRendererComponent.setBackground(table.getSelectionBackground());
            }
         }

         return tableCellRendererComponent;
      }
   }
}
